require 'logger'
require 'rflow-components-http'

RFlow.logger = Logger.new STDOUT
RFlow.logger.level = 5

def decode_avro(schema_string, serialized_object)
  schema = Avro::Schema.parse(schema_string)
  Avro::IO::DatumReader.new(schema, schema).read Avro::IO::BinaryDecoder.new(StringIO.new(serialized_object))
end

def encode_avro(schema_string, object)
  schema = Avro::Schema.parse(schema_string)
  sio = StringIO.new
  Avro::IO::DatumWriter.new(schema).write object, Avro::IO::BinaryEncoder.new(sio)
  sio.string
end
